Index: /NEMO/trunk/tests/STATION_ASF/EXPREF/launch_sasf.sh
===================================================================
--- /NEMO/trunk/tests/STATION_ASF/EXPREF/launch_sasf.sh	(revision 14071)
+++ /NEMO/trunk/tests/STATION_ASF/EXPREF/launch_sasf.sh	(revision 14072)
@@ -5,29 +5,93 @@
 # Script to launch a set of STATION_ASF simulations
 #
+#  Ocean-only version....
+#
 # L. Brodeau, 2020
 #
 ################################################################
 
-# What directory inside "tests" actually contains the compiled "nemo.exe" for STATION_ASF ?
-TC_DIR="STATION_ASF2"
-
-expdir=`basename ${PWD}`; # we expect "EXPREF" or "EXP00" normally...
-
-# NEMOGCM root directory:
-NEMO_ROOT_DIR=`pwd | sed -e "s|/tests/STATION_ASF/${expdir}||g"`
+CONFIG="STATION_ASF" ; # general name of the configuration
+CONFIG_BLD="STATION_ASF2" ; # name of config as build in NEMO... (directory inside "tests" actually contains the compiled test-case?)
+
+# Atmo + SSX forcing to use and sea-ice support?
+#     => FORCING: name of forcing
+#     => i_sea_ice: whether to compute fluxes over sea-ice as well
+#     => SFORC: string sufficient to copy relevant files as in "*${SFORC}*.nc"
+FORCING="PAPA"                 ; i_sea_ice=0 ; SFORC="Station_PAPA_50N-145W"
+#FORCING="ERA5_NorthGreenland" ; i_sea_ice=1 ; SFORC="ERA5_NorthGreenland_surface_84N_-36E_1h" ; # WITH ice/air flux computation
+#FORCING="ERA5_NorthGreenland" ; i_sea_ice=0 ; SFORC="ERA5_NorthGreenland_surface_84N_-36E_1h" ; # "ERA5_arctic" WITHOUT ice/air flux computation
+
+
+# Root directory NEMOGCM reference depository where to fetch compiled STATION_ASF nemo.exe + default namelists:
+NEMO_REF_DIR="`dirname ${PWD} | sed -e 's|/tests/STATION_ASF||g'`" ; # that should normally do the trick!
 
 # NEMOGCM root directory where to fetch compiled STATION_ASF nemo.exe:
-SASF_WRK_DIR="${NEMO_ROOT_DIR}/tests/${TC_DIR}"
+SASF_WRK_DIR="${NEMO_REF_DIR}/tests/${CONFIG_BLD}"
+
+# DATA_IN_DIR => Directory containing sea-surface + atmospheric forcings:
+DATA_IN_DIR="${NEMO_REF_DIR}/tests/${CONFIG}/input_data"
 
 # Directory where to run the simulation:
-PROD_DIR="${HOME}/tmp/STATION_ASF"
-
+PROD_DIR="${HOME}/tmp/${CONFIG}"
+
+# MPI launch command for your system
+# Even though we are running on 1 proc here, NEMO has likely been compiled with MPI,
+# if it's not the case then just leave "MPI_LAUNCH" void...
+MPI_LAUNCH="mpirun -n 1"
 
 ####### End of normal user configurable section #######
-
 #================================================================================
 
-SASF_REF_DIR="${NEMO_ROOT_DIR}/tests/STATION_ASF"
-if [ ! -d ${SASF_REF_DIR} ]; then echo " Mhhh, no EXPREF directory ${SASF_REF_DIR} !"; exit; fi
+iconv_1d=1
+if [ "`which ncks`" = "" ]; then
+    echo
+    echo "WARNING: you do not seem to have NCO installed here... You should!"
+    echo "      => anyway! will do without, but output netCDF files will remaine 3x3 in space :( "
+    echo
+    iconv_1d=0
+    sleep 3
+fi
+
+HERE=`pwd`
+
+echo
+
+# Is the nemo.exe of STATION_ASF compiled with sea-ice support (SI3) ?
+i_si3=0
+FCPP="${SASF_WRK_DIR}/cpp_${CONFIG_BLD}.fcm"
+if [ ! -f ${FCPP} ]; then echo " Mhhh, we could not find 'cpp_STATION_ASF.fcm' into `dirname ${FCPP}` !"; exit; fi
+ca=`cat ${FCPP} | grep 'key_si3'`
+
+if [ "${ca}" = "" ]; then
+    echo " *** NEMO was NOT compiled with sea-ice support (SI3) !" ; echo
+    if [ ${i_sea_ice} -eq 1 ]; then
+        echo " ===> so you cannot request ice-air flux computation !"
+        echo "     ===> please set i_sea_ice=0 or compile STATION_ASF with CPP key 'key_si3' !"
+        echo ; exit
+    fi
+else
+    echo " *** NEMO was apparently compiled with sea-ice support (SI3) !" ; echo
+    i_si3=1
+fi
+
+# Ok things are a bit different whether we compute fluxes over open ocean only or open ocean + sea-ice
+
+DIR_F=`echo ${FORCING} | cut -d'_' -f1` ; # "ERA5_blabla" => "ERA5" !
+
+if [ ${i_sea_ice} -eq 1 ]; then
+    # OPEN-OCEAN/AIR + SEA-ICE/AIR flux computation
+    #   - simpler if we only use one Open-ocean/air algo (ECMWF)
+    LIST_OA_ALGOS="ECMWF" ;          # list of air-sea algorithms to test
+    LIST_IA_ALGOS="AN05 LG15 LU12 CSTC" ; # list of air-ice algorithms to test
+    DIR_NL=${DIR_F}/oce+ice ; # where to fetch the namelists from...
+else
+    # Only OPEN-OCEAN/AIR flux computation
+    LIST_OA_ALGOS="NCAR ECMWF COARE3p6 ANDREAS"; # list of air-sea algorithms to test
+    LIST_IA_ALGOS=""
+    DIR_NL=${DIR_F}/oce ; # where to fetch the namelists from...
+fi
+if [ ! -d ${DIR_NL} ]; then echo " Mhhh, ${DIR_NL} not found !"; exit; fi
+
+
 
 # NEMO executable to use is:
@@ -35,10 +99,12 @@
 if [ ! -f ${NEMO_EXE} ]; then echo " Mhhh, no compiled 'nemo.exe' found into `dirname ${NEMO_EXE}` !"; exit; fi
 
-DATA_IN_DIR="${SASF_REF_DIR}/input_data" ; # Directory containing sea-surface + atmospheric input data
-if [ ! -d ${DATA_IN_DIR} ]; then echo "PROBLEM!!! => did not find directory 'input_data' with input forcing..."; exit; fi
-
-SASF_EXPREF=${SASF_REF_DIR}/${expdir}  ; # STATION_ASF EXPREF directory from which to use namelists and XIOS xml files...
-if [ ! -d ${SASF_EXPREF} ]; then echo " Mhhh, no ${expdir} directory ${SASF_EXPREF} !"; exit; fi
-
+SASF_EXPREF=`pwd`  ; # STATION_ASF EXPREF directory from which to use namelists and XIOS xml files...
+
+CFGS_SHARED="${NEMO_REF_DIR}/cfgs/SHARED"
+if [ ! -d ${CFGS_SHARED} ]; then echo "PROBLEM!!! => could not find directory ${CFGS_SHARED} !"; exit; fi
+
+if [ ! -d ${DATA_IN_DIR} ]; then echo "PROBLEM!!! => could not find directory 'input_data' with input forcing..."; exit; fi
+
+cdt_cmpl="`\ls -l ${NEMO_EXE} | cut -d' ' -f 6,7,8`"
 
 echo "###########################################################"
@@ -46,7 +112,8 @@
 echo "###########################################################"
 echo
-echo "  * NEMO reference root directory is: ${NEMO_ROOT_DIR}"
+echo "  * NEMO reference root directory is: ${NEMO_REF_DIR}"
 echo "  * STATION_ASF work directory is: ${SASF_WRK_DIR}"
 echo "       ==> NEMO EXE to use: ${NEMO_EXE}"
+echo "           ==> compiled: ${cdt_cmpl} !"
 echo
 echo "  * Input forcing data into: ${DATA_IN_DIR}"
@@ -55,44 +122,112 @@
 echo "       ==> ${SASF_EXPREF}"
 echo
+sleep 2
 
 mkdir -p ${PROD_DIR}
 
 rsync -avP ${NEMO_EXE}          ${PROD_DIR}/
-
-for ff in "context_nemo.xml" "domain_def_nemo.xml" "field_def_nemo-oce.xml" "file_def_nemo-oce.xml" "grid_def_nemo.xml" "iodef.xml" "namelist_ref"; do
+ln -sf      ${NEMO_EXE}          ${PROD_DIR}/nemo.exe.lnk
+
+
+# XIOS xml file
+################
+
+list_xml_ref="field_def_nemo-oce.xml domain_def_nemo.xml grid_def_nemo.xml"
+list_xml_cfg="iodef.xml file_def_nemo-oce.xml"
+fcntxt="context_nemo_OCE.xml"
+if [ ${i_sea_ice} -eq 1 ]; then
+    list_xml_ref+=" field_def_nemo-ice.xml"
+    list_xml_cfg+=" file_def_nemo-ice.xml"
+    fcntxt="context_nemo_OCE+ICE.xml"
+fi
+
+# The "context_nemo.xml" file:
+if [ ! -f ${SASF_EXPREF}/${fcntxt} ]; then echo " Mhhh, ${fcntxt} not found into ${SASF_EXPREF} !"; exit; fi
+rsync -avPL ${SASF_EXPREF}/${fcntxt} ${PROD_DIR}/context_nemo.xml
+
+# All remaining "*.xml" files:
+for ff in ${list_xml_cfg} ; do
     if [ ! -f ${SASF_EXPREF}/${ff} ]; then echo " Mhhh, ${ff} not found into ${SASF_EXPREF} !"; exit; fi
     rsync -avPL ${SASF_EXPREF}/${ff} ${PROD_DIR}/
 done
+for ff in ${list_xml_ref} ; do
+    if [ ! -f ${CFGS_SHARED}/${ff} ]; then echo " Mhhh, ${ff} not found into ${CFGS_SHARED} !"; exit; fi
+    rsync -avPL ${CFGS_SHARED}/${ff} ${PROD_DIR}/
+done
+
 
 # Copy forcing to work directory:
-rsync -avP ${DATA_IN_DIR}/Station_PAPA_50N-145W*.nc ${PROD_DIR}/
-
-for CASE in "ECMWF" "COARE3p6" "NCAR" "ECMWF-noskin" "COARE3p6-noskin"; do
-
-    echo ; echo
-    echo "============================="
-    echo " Going for ${CASE} experiment"
-    echo "============================="
-    echo
-
-    scase=`echo "${CASE}" | tr '[:upper:]' '[:lower:]'`
-
-    rm -f ${PROD_DIR}/namelist_cfg
-    rsync -avPL ${SASF_EXPREF}/namelist_${scase}_cfg ${PROD_DIR}/namelist_cfg
-
-    cd ${PROD_DIR}/
-    echo
-    echo "Launching NEMO !"
-    ./nemo.exe 1>out_nemo.out 2>err_nemo.err
-    echo "Done!"
-    echo
-
-    # Moving output files:
-    mkdir -p output
-    mv -f STATION_ASF-${CASE}_*_grid*.nc output/
+echo ; echo "Forcing files to use:"
+\ls -l ${DATA_IN_DIR}/*${SFORC}*.nc
+echo
+rsync -avPL ${DATA_IN_DIR}/*${SFORC}*.nc ${PROD_DIR}/
+echo; echo
+
+
+if [ "${LIST_IA_ALGOS}" = "" ]; then LIST_IA_ALGOS="none"; fi
+
+echo
+
+for OA_A in ${LIST_OA_ALGOS}; do
+    for IA_A in ${LIST_IA_ALGOS}; do
+
+        echo        
+        CASE="${OA_A}"
+        if [ ${i_sea_ice} -eq 1 ] && [ "${IA_A}" != "none" ]; then CASE="${OA_A}-${IA_A}"; fi
+
+        echo ; echo
+        echo "======================================================================="
+        echo " Going for experiment: ${CASE} bulk param. with ${FORCING} forcing "
+        echo "======================================================================="
+        echo
+
+        scase=`echo "${CASE}" | tr '[:upper:]' '[:lower:]'`
+
+        rm -f ${PROD_DIR}/namelist_cfg
+        fnml="${SASF_EXPREF}/${DIR_NL}/namelist_${scase}_cfg"
+        if [ ! -f ${fnml} ]; then echo " Mhhh, test namelist ${fnml} not found !"; exit; fi
+
+        echo "   ===> namelist to use is: ${DIR_NL}/namelist_${scase}_cfg !"; echo
+        
+        # The namelists:
+        #rsync -avPL ${fnml} ${PROD_DIR}/namelist_cfg
+        sed -e "s|<FORCING>|${FORCING}|g" -e "s|<SFORC>|${SFORC}|g" ${fnml} > ${PROD_DIR}/namelist_cfg
+
+        rsync -avPL ${CFGS_SHARED}/namelist_ref                    ${PROD_DIR}/namelist_ref
+        if [ ${i_sea_ice} -eq 1 ]; then
+            rsync -avPL ${SASF_EXPREF}/namelist_ice_cfg ${PROD_DIR}/namelist_ice_cfg
+            rsync -avPL ${CFGS_SHARED}/namelist_ice_ref ${PROD_DIR}/namelist_ice_ref
+        fi
     
-    # Saving logs:
-    mkdir -p ${CASE}_log
-    mv -f *.out *.err ocean.output output.namelist.dyn ${CASE}_log/
+        cd ${PROD_DIR}/
+        echo
+        echo "Launching NEMO ! (==> ${MPI_LAUNCH} ./nemo.exe)"
+        ${MPI_LAUNCH} ./nemo.exe 1>out_nemo.out 2>err_nemo.err
+        echo "Done!"
+        echo
+
+        # Moving output files:
+        mkdir -p output
+        mv -f ${CONFIG}-${CASE}_${FORCING}_*_grid*.nc output/
+        if [ ${i_sea_ice} -eq 1 ]; then mv -f ${CONFIG}-${CASE}_${FORCING}_*_icemod.nc output/; fi
+
+        # Saving logs:
+        mkdir -p ${CASE}_${FORCING}_log
+        mv -f *.out *.err ocean.output output.namelist.dyn ${CASE}_${FORCING}_log/
+
+        if [ ${iconv_1d} -eq 1 ]; then
+        # Making 3x3 to 1 !
+        cd output/
+        list=`\ls ${CONFIG}*${CASE}_${FORCING}_*.nc | grep -v '_restart_'| grep -v '_1p.nc'`
+        for ff in ${list}; do
+            echo
+            fn=`echo ${ff} | sed -e "s|.nc|_1p.nc|g"`
+            CMD="ncks -O -d x,1 -d y,1 ${ff} -o ${fn}"
+            echo " *** ${CMD}"; ${CMD}
+            echo
+        done
+        fi
+
+    done
 
 done
Index: /NEMO/trunk/tests/STATION_ASF/EXPREF/namelist_ice_cfg
===================================================================
--- /NEMO/trunk/tests/STATION_ASF/EXPREF/namelist_ice_cfg	(revision 14072)
+++ /NEMO/trunk/tests/STATION_ASF/EXPREF/namelist_ice_cfg	(revision 14072)
@@ -0,0 +1,85 @@
+!!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+!! SI3 configuration namelist: Overwrites SHARED/namelist_ice_ref
+!!              1 - Generic parameters                 (nampar)
+!!              2 - Ice thickness discretization       (namitd)
+!!              3 - Ice dynamics                       (namdyn)
+!!              4 - Ice ridging/rafting                (namdyn_rdgrft)
+!!              5 - Ice rheology                       (namdyn_rhg)
+!!              6 - Ice advection                      (namdyn_adv)
+!!              7 - Ice surface boundary conditions    (namsbc)
+!!              8 - Ice thermodynamics                 (namthd)
+!!              9 - Ice heat diffusion                 (namthd_zdf)
+!!             10 - Ice lateral melting                (namthd_da)
+!!             11 - Ice growth in open water           (namthd_do)
+!!             12 - Ice salinity                       (namthd_sal)
+!!             13 - Ice melt ponds                     (namthd_pnd)
+!!             14 - Ice initialization                 (namini)
+!!             15 - Ice/snow albedos                   (namalb)
+!!             16 - Ice diagnostics                    (namdia)
+!!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+!
+!------------------------------------------------------------------------------
+&nampar         !   Generic parameters
+!------------------------------------------------------------------------------
+   jpl              =   1             !  number of ice  categories
+/
+!------------------------------------------------------------------------------
+&namitd         !   Ice discretization
+!------------------------------------------------------------------------------
+/
+!------------------------------------------------------------------------------
+&namdyn         !   Ice dynamics
+!------------------------------------------------------------------------------
+/
+!------------------------------------------------------------------------------
+&namdyn_rdgrft  !   Ice ridging/rafting
+!------------------------------------------------------------------------------
+/
+!------------------------------------------------------------------------------
+&namdyn_rhg     !   Ice rheology
+!------------------------------------------------------------------------------
+/
+!------------------------------------------------------------------------------
+&namdyn_adv     !   Ice advection
+!------------------------------------------------------------------------------
+/
+!------------------------------------------------------------------------------
+&namsbc         !   Ice surface boundary conditions
+!------------------------------------------------------------------------------
+/
+!------------------------------------------------------------------------------
+&namthd         !   Ice thermodynamics
+!------------------------------------------------------------------------------
+/
+!------------------------------------------------------------------------------
+&namthd_zdf     !   Ice heat diffusion
+!------------------------------------------------------------------------------
+/
+!------------------------------------------------------------------------------
+&namthd_da      !   Ice lateral melting
+!------------------------------------------------------------------------------
+/
+!------------------------------------------------------------------------------
+&namthd_do      !   Ice growth in open water
+!------------------------------------------------------------------------------
+/
+!------------------------------------------------------------------------------
+&namthd_sal     !   Ice salinity
+!------------------------------------------------------------------------------
+/
+!------------------------------------------------------------------------------
+&namthd_pnd     !   Melt ponds
+!------------------------------------------------------------------------------
+/
+!------------------------------------------------------------------------------
+&namini         !   Ice initialization
+!------------------------------------------------------------------------------
+/
+!------------------------------------------------------------------------------
+&namalb         !   albedo parameters
+!------------------------------------------------------------------------------
+/
+!------------------------------------------------------------------------------
+&namdia         !   Diagnostics
+!------------------------------------------------------------------------------
+/
Index: /NEMO/trunk/tests/STATION_ASF/EXPREF/plot_station_asf_ICE.py
===================================================================
--- /NEMO/trunk/tests/STATION_ASF/EXPREF/plot_station_asf_ICE.py	(revision 14072)
+++ /NEMO/trunk/tests/STATION_ASF/EXPREF/plot_station_asf_ICE.py	(revision 14072)
@@ -0,0 +1,279 @@
+#!/usr/bin/env python3
+# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
+#
+##########################################################################################
+# Post-diagnostic of STATION_ASF for air-ice fluxes (over sea-ice)
+#
+#  L. Brodeau, 2020
+##########################################################################################
+
+import sys
+from os import path, listdir
+import argparse as ap
+from math import floor, ceil, copysign, log
+import numpy as nmp
+from netCDF4 import Dataset,num2date
+import matplotlib as mpl
+mpl.use('Agg')
+import matplotlib.pyplot as plt
+import matplotlib.dates as mdates
+
+dir_figs='.'
+size_fig=(13,8.5)
+size_fig0=(12,10)
+
+clr_red = '#AD0000'
+clr_mod = '#008ab8'
+
+rDPI=100.
+
+#ffed00: yellow ON
+#E8A727: ornage
+
+l_color = [ '0.3' , '#E8A727', '0.1'  , '#008ab8'  ] ; # colors to differentiate algos on the plot
+l_width = [   2   ,    2     ,  1.5   ,    2       ] ; # line-width to differentiate algos on the plot
+l_style = [  '-'  ,    '-'   , '--'   ,   '-'      ] ; # line-style
+
+
+# Variables to compare between algorithms
+############################################
+crealm = 'sea-ice'
+L_VNEM = [   'Cd_ice',   'Ch_ice',   'qla_ice' ,   'qsb_ice'   ,  'qt_ice'    ,  'qlw_ice'  ,  'qsr_ice'  , 'taum_ice'  ]
+L_VARO = [     'Cd'  ,     'Ch'  ,   'Qlat'    ,    'Qsen'     ,   'Qnet'     ,   'Qlw'     ,    'Qsw'    ,  'Tau'      ]
+L_VARL = [ r'$C_{D}$', r'$C_{H}$', r'$Q_{lat}$', r'$Q_{sens}$' , r'$Q_{net}$' , r'$Q_{lw}$' , r'$Q_{sw}$' , r'$|\tau|$' ]
+L_VUNT = [     ''    ,     ''    , r'$W/m^2$'  , r'$W/m^2$'    , r'$W/m^2$'   , r'$W/m^2$'  , r'$W/m^2$'  , r'$N/m^2$'  ]
+L_BASE = [    0.0005 ,    0.0005 ,      5.     ,     5.        ,     5.       ,    5.       ,     5.      ,    0.05     ]
+L_PREC = [     3     ,     3     ,      0     ,      0        ,      0      ,      0        ,     0       ,     2       ]
+L_ANOM = [   False   ,   False   ,   True      ,    True       ,    True      ,    True     ,    True     ,   True      ]
+L_MAXT = [  10000.   ,     10000.,  10000.   ,  10000.      ,  10000.    ,  10000.      , 10000.     ,      1.5    ]
+L_MINT = [    0.001  ,     0.001 , -10000.   , -10000.      , -10000.    , -10000.      ,-10000.     ,   -10000.   ]
+
+
+# About STATION_ASF output files to read:
+cpref = 'STATION_ASF-'          ; np = len(cpref)
+csuff = '_icemod.nc'            ; ns = len(csuff)
+cclnd = '_1h_YYYY0101_YYYY1231' ; nc = len(cclnd)
+
+
+################## ARGUMENT PARSING / USAGE ################################################################################################
+parser = ap.ArgumentParser(description='Generate pixel maps of a given scalar.')
+#
+requiredNamed = parser.add_argument_group('required arguments')
+requiredNamed.add_argument('-d', '--dirout' , required=True,                 help='Path to (production) directory where STATION_ASF was run')
+requiredNamed.add_argument('-f', '--forcing', required=True, default="PAPA", help='Name of forcing (ex: PAPA, ERA5_arctic')
+#
+parser.add_argument('-C', '--conf',   default="STATION_ASF",  help='specify NEMO config (ex: STATION_ASF)')
+parser.add_argument('-s', '--ystart', default="2018",         help='specify first year of experiment (ex: 2018)')
+parser.add_argument('-e', '--yend',   default="2018",         help='specify last  year of experiment (ex: 2018)')
+#
+parser.add_argument('-t', '--itype',   default="png",         help='specify the type of image you want to create (ex: png, svg, etc.)')
+#parser.add_argument('-l', '--lev' , type=int, default=0,    help='specify the level to use if 3D field (default: 0 => 2D)')
+#parser.add_argument('-I', '--ice' , action='store_true',    help='draw sea-ice concentration layer onto the field')
+#
+args = parser.parse_args()
+#
+cdir_data = args.dirout
+cforcing  = args.forcing
+#
+CONF      = args.conf
+cy1       = args.ystart
+cy2       = args.yend
+#
+fig_ext   = args.itype
+#jk    = args.lev
+#lshow_ice = args.ice
+#
+#print(''); print(' *** cdir_data = ', cdir_data); print(' *** cforcing  = ', cforcing)
+#print(' *** CONF = ', CONF); print(' *** cy1 = ', cy1); print(' *** cy2 = ', cy2)
+###############################################################################################################################################
+
+
+
+# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+# Populating and checking existence of files to be read
+# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+
+dir_out = cdir_data+'/output'
+ldir = listdir(dir_out)
+cf_in    = []
+list_exp = []
+list_ext = [] ; # for title
+list_frc = []
+for fn in ldir:
+    fpn = dir_out+'/'+fn
+    if path.isfile(fpn):
+        if fn[:np]==cpref and fn[-ns:]==csuff and cforcing in fn:
+            print('\n file: '+fn)
+            clab = fn[np:-nc-ns]
+            [ cexp, cfrc ] = str.split(clab, '_', 1)
+            cexp = cexp.split('-')[1] ; # removing air-sea algo name...
+            cext = cexp
+            if   cexp == "LG15":
+                cext ="Lüpkes & Gryanik, 2015"
+            elif cexp == "LU12":
+                cext ="Lüpkes et al., 2012"
+            elif cexp == "AN05":
+                cext ="Andreas et al., 2005"
+            elif cexp == "CSTC":
+                cext ="Constant coefficients"
+            print('  ===> Experiment = '+cexp+' ('+cext+'), Forcing = '+cfrc)
+            list_exp.append(cexp)
+            list_ext.append(cext)
+            list_frc.append(cfrc)
+            cf_in.append(fpn)
+nbf = len( set(list_frc) )
+
+
+
+if nbf == 0:
+    print('PROBLEM: we found no files corresponding to a forcing!')
+    sys.exit(0)
+print("list_frc =>",list_frc)
+if not nbf == 1:
+    print('PROBLEM: we found files for more that one forcing: ', set(list_frc))
+    sys.exit(0)
+
+nb_exp = len(list_exp)
+
+
+print('\n\nThere are '+str(nb_exp)+' experiments to compare:')
+for ja in range(nb_exp): print('  * '+list_exp[ja]+'\n'+'     ==> '+cf_in[ja]+'\n')
+
+if nb_exp > len(l_color):
+    print('PROBLEM: the max number of experiments for comparison is '+str(len(l_color))+' for now...')
+    sys.exit(0)
+
+
+#-----------------------------------------------------------------
+
+
+def round_bounds( x1, x2,  base=5, prec=3 ):
+    rmin =  base * round( floor(float(x1)/base), prec )
+    rmax =  base * round(  ceil(float(x2)/base), prec )
+    return rmin, rmax
+
+
+# Getting time array from the first file:
+id_in = Dataset(cf_in[0])
+vt = id_in.variables['time_counter'][:]
+cunit_t = id_in.variables['time_counter'].units ; print(' "time_counter" is in "'+cunit_t+'"')
+id_in.close()
+Nt = len(vt)
+
+vtime = num2date(vt, units=cunit_t) ; # something human!
+vtime = vtime.astype(dtype='datetime64[D]')
+
+ii=Nt/300
+ib=max(ii-ii%10,1)
+xticks_d=int(30*ib)
+
+rat = 100./float(rDPI)
+params = { 'font.family':'Open Sans',
+           'font.size':       int(15.*rat),
+           'legend.fontsize': int(15.*rat),
+           'xtick.labelsize': int(15.*rat),
+           'ytick.labelsize': int(15.*rat),
+           'axes.labelsize':  int(16.*rat)
+}
+mpl.rcParams.update(params)
+font_inf = { 'fontname':'Open Sans', 'fontweight':'normal', 'fontsize':18.*rat }
+font_x   = { 'fontname':'Open Sans', 'fontweight':'normal', 'fontsize':15.*rat }
+
+
+# Now we compare output variables from bulk algorithms between them:
+
+nb_var = len(L_VNEM)
+
+xF  = nmp.zeros((Nt,nb_exp))
+xFa = nmp.zeros((Nt,nb_exp))
+
+
+for jv in range(nb_var):
+    print('\n *** Treating variable: '+L_VARO[jv]+' !')
+
+    for ja in range(nb_exp):
+        #
+        id_in = Dataset(cf_in[ja])
+        xF[:,ja] = id_in.variables[L_VNEM[jv]][:,1,1]  ; # only the center point of the 3x3 spatial domain!
+        if ja == 0: cvar_lnm = id_in.variables[L_VNEM[jv]].long_name
+        id_in.close()
+        #
+        id_toolarge, = nmp.where( xF[:,ja] > L_MAXT[jv] ) # 
+        xF[id_toolarge,ja] = L_MAXT[jv]
+        id_toosmall, = nmp.where( xF[:,ja] < L_MINT[jv] ) ; #print("id_toosmall =", id_toosmall)
+        xF[id_toosmall,ja] = L_MINT[jv]
+
+    idx_okay = nmp.where( nmp.abs(xF) < 1.e+10 )
+
+    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    fig = plt.figure(num = jv, figsize=size_fig, facecolor='w', edgecolor='k')
+    ax1 = plt.axes([0.083, 0.23, 0.9, 0.7])
+    ax1.set_xticks(vtime[::xticks_d])
+    ax1.xaxis.set_major_formatter(mdates.DateFormatter('%Y-%m-%d %H:%M:%S'))
+    plt.xticks(rotation='60', **font_x)
+
+    for ja in range(nb_exp):
+        fplot = nmp.ma.masked_where( xF[:,ja]==0., xF[:,ja] )
+        plt.plot(vtime, fplot, '-', color=l_color[ja], \
+                 linestyle=l_style[ja], linewidth=l_width[ja], label=list_ext[ja], alpha=0.6 ) #zorder=10+ja)
+
+    fmin, fmax = round_bounds( nmp.min(xF[idx_okay]) , nmp.max(xF[idx_okay]), base=L_BASE[jv], prec=L_PREC[jv])
+    ax1.set_ylim(fmin, fmax) ; ax1.set_xlim(vtime[0],vtime[Nt-1])
+    plt.ylabel(L_VARL[jv]+' ['+L_VUNT[jv]+']')
+
+    ax1.grid(color='k', linestyle='-', linewidth=0.3)
+    plt.legend(loc='best', ncol=1, shadow=True, fancybox=True)
+    ax1.annotate(cvar_lnm+', station: '+cforcing, xy=(0.5, 1.04), xycoords='axes fraction', \
+                 ha='center', bbox={'facecolor':'w', 'alpha':1., 'pad':10}, \
+                 zorder=50, **font_inf)
+    plt.savefig(L_VARO[jv]+'_'+cforcing+'_'+crealm+'.'+fig_ext, dpi=int(rDPI), transparent=False)
+    plt.close(jv)
+    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+
+
+
+    def symetric_range( pmin, pmax ):
+        # Returns a symetric f-range that makes sense for the anomaly of "f" we're looking at...
+        from math import floor, copysign, log, ceil
+        zmax = max( abs(pmax) , abs(pmin) )
+        romagn = floor(log(zmax, 10)) ; # order of magnitude of the anomaly  we're dealing with
+        rmlt = 10.**(int(romagn)) / 2.
+        frng = copysign( ceil(abs(zmax)/rmlt)*rmlt , zmax)
+        return frng
+
+
+    if L_ANOM[jv]:
+
+        for ja in range(nb_exp): xFa[:,ja] = xF[:,ja] - nmp.mean(xF,axis=1)
+
+        if nmp.sum(nmp.abs(xFa[:,:])) == 0.0:
+            print('     Well! Seems that for variable '+L_VARO[jv]+', choice of algo has no impact a all!')
+            print('          ==> skipping anomaly plot...')
+
+        else:
+
+            yrng = symetric_range( nmp.min(xFa) , nmp.max(xFa) )
+
+            #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+            fig = plt.figure(num = 10+jv, figsize=size_fig, facecolor='w', edgecolor='k')
+            ax1 = plt.axes([0.09, 0.23, 0.9, 0.7])
+            ax1.set_xticks(vtime[::xticks_d])
+            ax1.xaxis.set_major_formatter(mdates.DateFormatter('%Y-%m-%d %H:%M:%S'))
+            plt.xticks(rotation='60', **font_x)
+
+            for ja in range(nb_exp):
+                fplot = nmp.ma.masked_where( xFa[:,ja]==0., xFa[:,ja] )
+                plt.plot(vtime, fplot, '-', color=l_color[ja], \
+                         linewidth=l_width[ja], label=list_exp[ja], alpha=0.6) #, zorder=10+ja)
+
+            ax1.set_ylim(-yrng,yrng) ; ax1.set_xlim(vtime[0],vtime[Nt-1])
+            plt.ylabel(L_VARL[jv]+' ['+L_VUNT[jv]+']')
+            ax1.grid(color='k', linestyle='-', linewidth=0.3)
+            plt.legend(bbox_to_anchor=(0.45, 0.2), ncol=1, shadow=True, fancybox=True)
+            ax1.annotate('Anomaly of '+cvar_lnm+', station: '+cforcing, xy=(0.5, 1.04), xycoords='axes fraction', \
+                         ha='center', bbox={'facecolor':'w', 'alpha':1., 'pad':10}, \
+                         zorder=50, **font_inf)
+            plt.savefig(L_VARO[jv]+'_'+cforcing+'_anomaly_'+crealm+'.'+fig_ext, dpi=int(rDPI), transparent=False)
+            plt.close(10+jv)
+            #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
